; Repkeys - by David Reed
;
; Use SETKEY -19 PLAY "C:\\PDOX45\\REPKEYS" to make this work..
; Hit [Alt]-[R] to activate..

PROC RepkeysHelp()

; reset the CANVAS

ECHO OFF
ECHO NORMAL

FOR y FROM 2 TO 20
  @ y,08 ?? SPACES(63)
ENDFOR

SETMARGIN 12

@ 4,0

TEXT
   F3  - Inserts ASCII character 196 - CHR(196)
   F4  - Inserts ASCII character 205 - CHR(205)

   F5  - Captures a calc field to memory
   F6  - Places the most recently captured calc field

   F7  - Captures the current line of text to memory
   F8  - Places the most recently captured text line
   NOTE: F7 / F8 will not place the fields!

   F12 - Extended ASCII character chart
         (the most useful ones..)

   Alt X - Quit
ENDTEXT

FRAME DOUBLE FROM 2,8 TO 20,70
PAINTCANVAS ATTRIBUTE 63  2, 8,20,70

ENDPROC

; ----- GetCalc

PROC GetCalc()

PRIVATE c,cc,x,
        each.col

IF CURSORCHAR() = "A" OR CURSORCHAR() = "_" OR CURSORCHAR() = "9" THEN

   ECHO OFF

   MENU {Field} {CalcEdit} ENTER           ; Get the calc info..
   menu.choice = MENUCHOICE()
   ESC ESC ESC ESC

   IF menu.choice = "" THEN
      MESSAGE " Not a valid calc field.. "
      ECHO NORMAL
      RETURN
   ENDIF

   c = COLNO()                              ; Remember where we were..
   SYNCCURSOR
   cc = COL()

   f.info = FIELDINFO()
 
   ; Get the length of the field..

   WHILE (CURSORCHAR() = "A" OR CURSORCHAR() = "_") AND (FIELDINFO() = f.info)
         LEFT
         IF COLNO() = 1 THEN
            QUITLOOP
         ENDIF
   ENDWHILE

   IF COLNO() <> 1 THEN
      RIGHT
   ENDIF

   field.size = 0                   ; Get the field size.
   WHILE (CURSORCHAR() = "A" OR CURSORCHAR() = "_") AND (FIELDINFO() = f.info)
         field.size = field.size + 1
         RIGHT
   ENDWHILE
       
   CTRLHOME                         ; Go back to the original coordinates..
   FOR each.col FROM 2 TO c
       RIGHT
   ENDFOR
   SYNCCURSOR
   x = COL() - cc
   FOR each.col FROM 1 TO x
      RIGHT
   ENDFOR
   FOR each.col FROM 1 TO x
      LEFT
   ENDFOR

   ; we still may not be right..in the Rep Generator, using Ctrl+Arrows
   ; can take you further than the end of the report page..

   SYNCCURSOR

   IF COLNO() <> c THEN
      CTRLHOME
      CTRLRIGHT
      CTRLRIGHT
      CTRLRIGHT
      CTRLRIGHT
      CTRLRIGHT
      ; move back to where we belong..
      WHILE COLNO() <> c
         LEFT
      ENDWHILE
      SYNCCURSOR
      FOR each.col FROM 1 TO cc - 1
         LEFT
      ENDFOR
      FOR each.col FROM 1 TO cc - 1
         RIGHT
      ENDFOR
   ENDIF

   MESSAGE " MenuChoice captured.. "

   ECHO NORMAL

ELSE

   menu.choice = ""

ENDIF

ENDPROC

; ----- Chart()

PROC Chart()

PRIVATE x,y,z,c

; reset the CANVAS

ECHO OFF
ECHO NORMAL

FOR y FROM 2 TO 20
  @ y,08 ?? SPACES(63)
ENDFOR

FOR y FROM 0 TO 8                            ; nine rows

  c = ""

  FOR x FROM 1 TO 10                         ; ten chars in each row
     z = (y * 10) + 164 + x                  ; start with char 170
     c = c + " " + STRVAL(z) + " " + CHR(z)
  ENDFOR

  @ (y * 2) + 3, 9 ?? c

ENDFOR

FRAME DOUBLE FROM 2,8 TO 20,70
PAINTCANVAS ATTRIBUTE 63  2, 8,20,70

; paint the numbers..

FOR x FROM 0 TO 9
    PAINTCANVAS ATTRIBUTE 48 3,(x * 6) + 9,19,(x * 6) + 13
ENDFOR

ENDPROC

; ----- FPC

PROC FPC()

PRIVATE i

SWITCH

     CASE NOT ISASSIGNED(menu.choice) OR menu.choice = "" :
          MESSAGE " Hit F5 to load a calc field.. "
     CASE CURSORCHAR() <> " " :
          MESSAGE " Field must be placed in a clear area.. "
     OTHERWISE :

          ; Place the field..

          ECHO OFF
          MENU {Field} {Place} {Calculated} TYPEIN menu.choice
          ENTER ENTER HOME

          FOR i FROM 2 TO field.size
             RIGHT
          ENDFOR
          ENTER

          c = COLNO()                    ; Remember where we were..
          SYNCCURSOR
          cc = COL()
              
          CTRLHOME                       ; Go back to the original coordinates..
          FOR each.col FROM 2 TO c
              RIGHT
          ENDFOR
          SYNCCURSOR
          x = COL() - cc
          FOR each.col FROM 1 TO x
             RIGHT
          ENDFOR
          FOR each.col FROM 1 TO x
             LEFT
          ENDFOR

          ; we still may not be right..in the Rep Generator, using Ctrl+Arrows
          ; can take you further than the end of the report page..

          SYNCCURSOR

          IF COLNO() <> c THEN
             CTRLHOME
             CTRLRIGHT
             CTRLRIGHT
             CTRLRIGHT
             CTRLRIGHT
             CTRLRIGHT
             ; move back to where we belong..
             WHILE COLNO() <> c
                LEFT
             ENDWHILE
             SYNCCURSOR
             FOR each.col FROM 1 TO cc - 1
                LEFT
             ENDFOR
             FOR each.col FROM 1 TO cc - 1
                RIGHT
             ENDFOR
          ENDIF

          MESSAGE FIELDINFO()

          ECHO NORMAL

ENDSWITCH

ENDPROC

; ----- TypeCurLine
   
PROC TypeCurLine()

PRIVATE ins.mode,
        c,
        each.col

IF cur.line = "" AND old.cur <> "" THEN   ; in case pressed F7 by mistake,
   cur.line = old.cur                     ; reassign..
ENDIF

IF ISASSIGNED(cur.line) AND cur.line <> "" THEN

   ECHO OFF

   ins.mode = ISINSERTMODE()  ; remember current insertmode..

   IF NOT ins.mode THEN
      INS
   ENDIF
   
   c = COLNO()
   CTRLHOME
   ENTER UP                   ; Insert a new line
   TYPEIN cur.line            ; Insert the saved cur.line..

   INS                        ; Typeover mode

   CTRLHOME                   ; Go back to the original coordinates..
   FOR each.col FROM 2 TO c
       RIGHT
   ENDFOR

   IF ins.mode THEN           ; Back to original insertmode..
      INS
   ENDIF

   MESSAGE ""

   ECHO NORMAL

ELSE

   MESSAGE " Press F7 to load a CursorLine.. "

ENDIF

ENDPROC

; --------- Start wait..

ECHO NORMAL

PROMPT ""

field.info  = TRUE
menu.choice = ""
cur.line    = ""
old.cur     = ""

WHILE SYSMODE() = "Report" OR SYSMODE() = "Form"

   ; Get the cursor coordinates..

   y = IIF(LEN(STRVAL(ROWNO())) = 1,"0","") + STRVAL(ROWNO())
   z = IIF(LEN(STRVAL(COLNO())) = 1,"0","") + STRVAL(COLNO())

   SPEEDBAR "  " + y + ":" + z : -68,
            "F3 \"\""       : -61,
            "F4 \"\""       : -62,
            "F5=Get"         : -63,
            "F6=Plc"         : -64,
            "F7=Lin"         : -65,
            "F8=Plc"         : -66,
            "F9=Info" + IIF(field.info,"OFF","ON ") : -67,
            "F1 - Help"      : -59 

   x = GETCHAR()

   MESSAGE IIF(field.info,FIELDINFO(),"")
   
   SWITCH
        CASE x = -59  : RepkeysHelp()
        CASE x = -61  : ""
        CASE x = -62  : ""
        CASE x = -63  : GetCalc()
        CASE x = -64  : FPC()
        CASE x = -65  : old.cur  = cur.line      ; Save the old cursorline..
                        cur.line = CURSORLINE()
                        MESSAGE " Cursorline Captured... "
        CASE x = -66  : TypeCurLine()
        CASE x = -67  : field.info = NOT field.info
                        MESSAGE IIF(field.info AND
                         (SYSMODE() = "Report" OR SYSMODE() = "Form"),
                          FIELDINFO(),"")
        CASE x = -134 : Chart()
        CASE x = -45  : QUITLOOP

        OTHERWISE : KEYPRESS x
                    MESSAGE IIF(field.info AND
                     (SYSMODE() = "Report" OR SYSMODE() = "Form"),
                          FIELDINFO(),"")
   ENDSWITCH

ENDWHILE

RELEASE PROCS GetCalc,FPC,TypeCurLine,Chart
CLEARSPEEDBAR
